<?php

/* Greylisting Administration */
/* Jason Frisvold */

define('SM_PATH','../../');
                                                                                
/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');

/* Include our configuration file here */
include_once('config.php');

/* GLOBALS */
sqgetGlobalVar('username', $username, SQ_SESSION);
sqgetGlobalVar('add_entry', $add_entry);
sqgetGlobalVar('update', $update);
sqgetGlobalVar('delete', $delete);
sqgetGlobalVar('cancel', $cancel);
sqgetGlobalVar('record_id', $record_id);
if ($add_entry or $update) {
   sqgetGlobalVar('relay_ip', $relay_ip);
   sqgetGlobalVar('mail_from', $mail_from);
   sqgetGlobalVar('expire_time', $expire_time);
}

/* This function retrieves any whitelist entries for this user and displays them on the screen */
function display_whitelist () {
   global $user_email;

   $select_query = "SELECT id, relay_ip, mail_from, rcpt_to, record_expires, create_time FROM relaytofrom WHERE origin_type = 'MANUAL' AND rcpt_to = \"$user_email\" ORDER BY id LIMIT 10";
   $result = mysql_query($select_query);

   if ($myrow = mysql_fetch_array($result)) {
      echo "<CENTER><H3>Existing Whitelist Entries</H3>\n";
      echo "<TABLE BORDER=1>\n";
      echo "<TR><TD>ID</TD><TD>IP</TD><TD>From</TD><TD>To</TD><TD>Expires</TD><TD>Created</TD></TR>\n";

      do {
         if (! $myrow[1]) {
            $myrow[1] = "N/A";
         }
         if (! $myrow[2]) {
            $myrow[2] = "N/A";
         }
         printf("<TR><TD><A HREF=\"%s?record_id=%s\">%s</A></TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD></TR>\n",
            $PHP_SELF, $myrow[0], $myrow[0], $myrow[1], $myrow[2], $myrow[3], $myrow[4], $myrow[5]);
      } while ($myrow = mysql_fetch_row($result));

      echo "</TABLE></CENTER>\n";
   } else {
      echo "<CENTER><H3>No current WhiteList entries</H3></CENTER>\n";
   }
}

/* This function adds a new entry into the whitelist */
function add_entry_whitelist ($relay_ip, $mail_from, $user_email, $expire_time) {
   global $db;
   if (! $relay_ip and ! $mail_from) {
      echo "<H3>Error : You must enter either the Remote Mailserver IP or the Sender E-Mail Address</H3>\n";
      return;
   } else if (! $expire_time) {
      echo "<H3>Error : System error.  Please contact Technical Support</H3>\n";
      return;
   }

   if ($relay_ip and ! validate_ipaddr($relay_ip)) {
      echo "<H3>ERROR : The Remote Mailserver IP you entered is not a valid IP Address</H3>\n";
      return;
   }

   if ($mail_from and ! validate_email($mail_from)) {
      echo "<H3>ERROR : The Sender E-Mail Address you entered is not a valid E-Mail address</H3>\n";
      return;
   }

   $add_query = "INSERT INTO relaytofrom (relay_ip, mail_from, rcpt_to, record_expires, create_time, origin_type) VALUES (\"$relay_ip\", \"$mail_from\", \"$user_email\", date_add(now(), INTERVAL $expire_time HOUR), now(), 'MANUAL')";
   $result = mysql_query($add_query);
   if (! $result) {
         echo "<H3>ERROR : Database error.  Please contact technical support</H3>\n";
         echo "<H4>" . mysql_errno($db) . ": " . mysql_error($db) . "</H4>\n";
   } else {
      echo "<H3>Entry added to whitelist</H3>\n";
   }
}

/* This function deletes an entry from the whitelist */
function delete_entry_whitelist ($user_email, $record_id) {
   // First we get the entry and check to see if this entry belongs to the user
   $select_query = "SELECT rcpt_to FROM relaytofrom WHERE id = $record_id";
   $result = mysql_query($select_query);
   // If the entry *does* belong to the user, we can safely delete it
   if (mysql_result($result,0,"rcpt_to") == "$user_email") {
      $delete_query = "DELETE FROM relaytofrom WHERE id=$record_id";
      $result = mysql_query($delete_query);
      if (! $result) {
         echo "<H3>ERROR : Database error.  Please contact technical support</H3>\n";
      } else {
         echo "<H3>Entry removed from whitelist</H3>\n";
      }
   } else { // If not, we report an error and return
      echo "<H3>ERROR : This entry does not belong to you</H3>\n";
      echo "<H3>Whitelist Entry not deleted</H3>\n";
      return;
   }
}

/* This function updates an existing entry in the whitelist */
function update_entry_whitelist ($relay_ip, $mail_from, $user_email, $expire_time, $record_id) {
   global $db;
   if (! $relay_ip and ! $mail_from) {
      echo "<H3>Error : You must enter either the Remote Mailserver IP or the Sender E-Mail Address</H3>\n";
      return;
   } else if (! $expire_time) {
      echo "<H3>Error : System error.  Please contact Technical Support</H3>\n";
      return;
   }

   if ($relay_ip and ! validate_ipaddr($relay_ip)) {
      echo "<H3>ERROR : The Remote Mailserver IP you entered is not a valid IP Address</H3>\n";
      return;
   }

   if ($mail_from and ! validate_email($mail_from)) {
      echo "<H3>ERROR : The Sender E-Mail Address you entered is not a valid E-Mail address</H3>\n";
      return;
   }

   $update_query = "UPDATE relaytofrom SET relay_ip=\"$relay_ip\", mail_from=\"$mail_from\", rcpt_to=\"$user_email\", record_expires=date_add(now(), INTERVAL $expire_time HOUR), create_time=now(), origin_type=\"MANUAL\" WHERE id=$record_id";
   $result = mysql_query($update_query);
   if (! $result) {
         echo "<H3>ERROR : Database error.  Please contact technical support</H3>\n";
         echo "<H4>" . mysql_errno($db) . ": " . mysql_error($db) . "</H4>\n";
   } else {
      echo "<H3>Entry Updated in whitelist</H3>\n";
   }
}

/* This function displays the form to add entries */
function display_entryform($displaytype, $relay_ip='', $mail_from='', $expire_time='', $record_id='') {
   echo "<BR><BR>\n";
   echo "<CENTER><FORM METHOD=\"post\" ACTION=\"greylist.php\">\n";
   echo "   <TABLE BORDER=0>\n";
   echo "      <TR><TD>Remote Mailserver IP</TD><TD><INPUT TYPE=\"text\" NAME=\"relay_ip\" VALUE=\"$relay_ip\"></TD></TR>\n";
   echo "      <TR><TD>E-Mail Address of Sender</TD><TD><INPUT TYPE=\"text\" NAME=\"mail_from\" VALUE=\"$mail_from\"></TD></TR>\n";
   echo "      <TR><TD>Time until this entry expires</TD><TD><SELECT NAME=\"expire_time\">\n";
   echo "         <OPTION";
   if ($expire_time == 1) { echo " SELECTED"; }
   echo " VALUE=\"1\">1 Hour\n";
   echo "         <OPTION";
   if ($expire_time == 6) { echo " SELECTED"; }
   echo " VALUE=\"6\">6 Hours\n";
   echo "         <OPTION";
   if ($expire_time == 12) { echo " SELECTED"; }
   echo " VALUE=\"12\">12 Hours\n";
   echo "         <OPTION";
   if ($expire_time == 24) { echo " SELECTED"; }
   echo " VALUE=\"24\">1 Day\n";
   echo "         <OPTION";
   if ($expire_time == 168) { echo " SELECTED"; }
   echo " VALUE=\"168\">1 Week\n";
   echo "      </SELECT></TD></TR>\n";
   echo "   </TABLE><BR>\n";
   if ($displaytype) {
      echo "   <INPUT TYPE=\"Hidden\" NAME=\"record_id\" VALUE=\"$record_id\">\n";
      echo "   <INPUT TYPE=\"Submit\" NAME=\"update\" VALUE=\"Update Entry\">\n";
      echo "   <INPUT TYPE=\"Submit\" NAME=\"delete\" VALUE=\"Delete Entry\">\n";
      echo "   <INPUT TYPE=\"Submit\" NAME=\"cancel\" VALUE=\"Cancel\">\n";
   } else {
      echo "   <INPUT TYPE=\"Submit\" NAME=\"add_entry\" VALUE=\"Add Entry\">\n";
   }
   echo "</FORM></CENTER>\n";
   echo "<LI>The Remote Mailserver IP corresponds to the IP Address of the mailserver that is sending you an email.  This field is normally not required.\n";
   echo "<LI>The Email Address of the Sender corresponds to the E-Mail address of the person you are expecting an email from. This is the field that is normally used.\n";
   echo "<LI>The expire time causes the entry to be deleted.  You may choose 1 hour, 6 hours, 12 hours, 1 day, or 1 week.\n";
}

/* Ok, so I stole this..  :)  PHP Mailing list */
/* This validates an email address and returns 1 if it's valid */
function validate_email($emailaddr) {
   if (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
   '@'.
   '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
   '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $emailaddr)) {
      return(1); // Valid
   }
   return(0); // Invalid
}

/* I wrote this one myself :) */
/* This validates an IP address of 3 or 4 octets */
/* Return is 1 if it's valid, 0 if not */
function validate_ipaddr($ipaddr) {
   if (preg_match("/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/", $ipaddr ,$octet) or preg_match("/^(\d+)\.(\d+)\.(\d+)$/", $ipaddr ,$octet)) {
      $count = count($octet);
      for ($i = 1; $i < $count; $i++) {
         if ($octet[$i] < 0 or $octet[$i] > 255) {
            return(0); // Invalid (octet is out of range)
         }
      }
      return(1); // Valid
   }
   return(0); // Invalid (does not match the regex for a valid IP)
}

/* This is the main() function of this file */
$db = mysql_connect($db_host, $db_login, $db_pass);
mysql_select_db($db_name,$db);

/* Check to see if the username is a valid email address */
/* If it's not, add the defaultdomain to the end of it */
if (! validate_email($username)) {
   $user_email = "$username@$default_domain";
} else {
   $user_email = $username;
}

displayPageHeader($color, "");

if ($add_entry) {
   add_entry_whitelist($relay_ip, $mail_from, $user_email, $expire_time);
   display_whitelist();
   display_entryform(0);
} else if ($delete) {
   delete_entry_whitelist($user_email, $record_id);
   display_whitelist();
   display_entryform(0);
} else if ($update) {
   update_entry_whitelist($relay_ip, $mail_from, $user_email, $expire_time, $record_id);
   display_whitelist();
   display_entryform(0);
} else if ($record_id) {
   $select_query = "SELECT relay_ip, mail_from, record_expires FROM relaytofrom WHERE id = $record_id";
   $result = mysql_query($select_query);
   $relay_ip = mysql_result($result,0,"relay_ip");
   $mail_from = mysql_result($result,0,"mail_from");
   $expire_time = mysql_result($result,0,"record_expires");
   display_entryform(1, $relay_ip, $mail_from, $expire_time, $record_id);
} else {
   if ($cancel) {
      echo "Action Cancelled\n";
   }
   display_whitelist();
   display_entryform(0);
}

mysql_close($db);

?>

</BODY></HTML>
